IsCrowd3D = 0

function CrowdUpdate()
	local as = gSportsRNA
	local state = as:GetTable("")
	local crowd = as:GetTable("")
		
	db.crowd.lightID = as:GetInt(state, "wvAttribEnvLighting")
	db.crowd.homeTeamID = as:GetInt(crowd, "homeTeamID")
	db.crowd.awayTeamID = as:GetInt(crowd, "awayTeamID")
	
	db.crowd.homeKitTeamID = as:GetInt(crowd, "homeKitTeamID")
	db.crowd.homeKitTypeID = as:GetInt(crowd, "homeKitTypeID")
	db.crowd.awayKitTeamID = as:GetInt(crowd, "awayKitTeamID")
	db.crowd.awayKitTypeID = as:GetInt(crowd, "awayKitTypeID")

	local weather = as:GetInt(state, "wvAttribStadWeather" )
	if (weather == 1 or weather == 2) then
		db.crowd.wet = 1
	else
		db.crowd.wet = 0
	end
end

function CrowdAssetBind(crowd)
	local gr = gRenderables
	
	local settingTable = gSportsRNA:GetTable("Settings")
	gSportsRNA:SetInt(settingTable, "IsCrowd3D", IsCrowd3D) 
	
	local lod = 0
	local priority = 1
	
	gr:AddCallback(crowd, lod, "CrowdUpdate()")
	
	gr:AddAsset(crowd, lod, "shader", "data/fifarna/shader.big", priority)
	
	-- Characters per group
	local characters = 4
	local groupcount = 3
	local path = "data/sceneassets/crowd/"
	local pathCrowd3d = "data/sceneassets/crowd13/"
	
	gr:AddAsset(crowd, lod, "crowd_common_textures", path.."crowd_common_textures.rx3", priority)
	
	for i=0,groupcount-1 do
		for j=0,characters-1 do
			local meshpart = "bodymesh_"..i.."_"..j
			local texpart = "bodytex_"..i.."_"..j
			-- if it's the 4th mesh in an away or neutral zone, create a jersey crowd character
			-- i == 0 -> neutral section
			-- j == 3 -> 4th mesh
			
			if (IsCrowd3D == 1) then
				-- todo: FS4 assets
				local ethnicity = 0
				local glod = 3
				gr:AddAsset(crowd, lod, meshpart, pathCrowd3d.."crowd_"..j.."_"..ethnicity.."_"..glod..".rx3", priority)
				gr:AddAsset(crowd, lod, texpart, pathCrowd3d.."crowd_"..j.."_"..ethnicity.."_0_textures.rx3", priority)
				
				gr:CreateMaterial(crowd, lod, meshpart, "crowd_body.fx")
				gr:SetTexture(crowd, lod, meshpart, "textures", "diffuseTexture", texpart, "") -- grabs first texture from the texlib
			else
				if (j == 3 and i > 0) then
					-- create mesh for body without jersey
					local bodymesh = meshpart.."_0"
					gr:AddAsset(crowd, lod, bodymesh, path.."crowd_0_4_${db.crowd.lightID}_${db.crowd.wet}.rx3", priority)
					gr:AddAsset(crowd, lod, texpart, path.."crowd_0_4_${db.crowd.lightID}_${db.crowd.wet}_textures.rx3", priority)
					
					gr:CreateMaterial(crowd, lod, bodymesh, "crowd_body.fx")
					gr:SetSubMesh(crowd, lod, bodymesh, "crowd_body")
					gr:SetTexture(crowd, lod, bodymesh, "textures", "diffuseTexture", texpart, "") -- grabs first texture from the texlib
					
					-- create mesh for jersey
					local jerseymesh = meshpart.."_1"
					gr:AddAsset(crowd, lod, jerseymesh, path.."crowd_0_4_${db.crowd.lightID}_${db.crowd.wet}.rx3", priority)
					
					gr:CreateMaterial(crowd, lod, jerseymesh, "crowd_jersey.fx")
					gr:SetSubMesh(crowd, lod, jerseymesh, "crowd_jersey")
					if i == 1 then
						-- home group
						gr:SetTextureFromRuntime(crowd, lod, jerseymesh, "textures", "diffuseTexture", "jersey_${db.crowd.homeKitTeamID}_${db.crowd.homeKitTypeID}_0_0")
					else
						-- away group
						gr:SetTextureFromRuntime(crowd, lod, jerseymesh, "textures", "diffuseTexture", "jersey_${db.crowd.awayKitTeamID}_${db.crowd.awayKitTypeID}_0_1")
					end
					gr:SetTexture(crowd, lod, jerseymesh, "textures", "detailTexture", "crowd_common_textures", "crowdjersey_am")
				else
					gr:AddAsset(crowd, lod, meshpart, path.."crowd_0_"..j.."_${db.crowd.lightID}_${db.crowd.wet}.rx3", priority)
					gr:AddAsset(crowd, lod, texpart, path.."crowd_0_"..j.."_${db.crowd.lightID}_${db.crowd.wet}_textures.rx3", priority)
					
					gr:CreateMaterial(crowd, lod, meshpart, "crowd_body.fx")
					gr:SetTexture(crowd, lod, meshpart, "textures", "diffuseTexture", texpart, "") -- grabs first texture from the texlib
				end
			end
		end
	end
	
	
	-- Chairs
	gr:AddAsset(crowd, lod, "chairmesh_0", "data/sceneassets/crowdchair/crowdchair_0.rx3", priority)
	gr:AddAsset(crowd, lod, "chairtex_0", "data/sceneassets/crowdchair/chaircmn_textures.rx3", priority)
	gr:CreateMaterial(crowd, lod, "chairmesh_0", "crowd_chair.fx")
	gr:SetTexture(crowd, lod, "chairmesh_0", "textures", "diffuseTexture", "chairtex_0", "")

	-- Scarves
	local scarfcount = 4
	for i=0,groupcount-1 do
		for j=0,scarfcount-1 do
			local meshpart = "scarfmesh_"..i.."_"..j
			local texpart = "scarftex_"..i.."_"..j
			local flagindex = math.fmod(j, 2)
			gr:AddAsset(crowd, lod, meshpart, path.."crowd_scarf_0.rx3", priority)
			gr:CreateMaterial(crowd, lod, meshpart, "crowd_accs.fx")
			
			if (i < 2) then
				gr:AddAsset(crowd, lod, texpart, "data/sceneassets/flag/flag_${db.crowd.homeTeamID}.rx3", priority)
				gr:SetTexture(crowd, lod, meshpart, "textures", "diffuseTexture", texpart, "flag_${db.crowd.homeTeamID}_"..flagindex)
			else
				gr:AddAsset(crowd, lod, texpart, "data/sceneassets/flag/flag_${db.crowd.awayTeamID}.rx3", priority)
				gr:SetTexture(crowd, lod, meshpart, "textures", "diffuseTexture", texpart, "flag_${db.crowd.awayTeamID}_"..flagindex)
			end
		end
	end

	-- banner textures
	-- names indexed as follows
	-- 0 - empty
	-- 1 - home
	-- 2 - away
	-- 3 - neutral
	gr:AddAsset(crowd, lod, "bannertex0", "data/sceneassets/banner/banner_0.rx3", priority)
	gr:AddAsset(crowd, lod, "bannertex1", "data/sceneassets/banner/banner_${db.crowd.homeTeamID}.rx3;data/sceneassets/banner/banner_0.rx3", priority)
	gr:AddAsset(crowd, lod, "bannertex2", "data/sceneassets/banner/banner_${db.crowd.awayTeamID}.rx3;data/sceneassets/banner/banner_0.rx3", priority)
	gr:AddAsset(crowd, lod, "bannertex3", "data/sceneassets/banner/banner_0.rx3", priority)

	return crowd
end
